'
' Astro Hero 1.1
' Copyright by Stefan Vogt 1994 - 1997
'

'Declare subs
DECLARE SUB ErrorMessages (Error$)
DECLARE SUB FadeOut (FadeMode$, FadeColor%)
DECLARE SUB GetText (x%, y%, Lenght%, Format$, TextColor%, Special$)
DECLARE SUB HallOfFame (WhichHighscore$)
DECLARE SUB HoldOn (Lenght!)
DECLARE SUB LoadConfiguration ()
DECLARE SUB MainMenu ()
DECLARE SUB PlaySound (WhichSound$)
DECLARE SUB PlayTheGame ()
DECLARE SUB Quit ()
DECLARE SUB RGB (ColorToChange%, r&, G&, B&)
DECLARE SUB ShowIntro ()
DECLARE SUB ShowManual ()
DECLARE SUB ShowMessage (WhichMessage$)
DECLARE SUB ShowShip (WhichShip%)
DECLARE SUB ShowStatus (WhichStatus$)
DECLARE SUB ShowTimber (StartPercent!, EndPercent!)
'

'Types
TYPE HsArray
  HsName AS STRING * 20
  HsScore AS INTEGER
END TYPE
'

'Dim arrays
REM $DYNAMIC
OPTION BASE 1
DIM PlayRed%(0 TO 2431), FameRed%(2432 TO 4171), ManualRed%(4172 TO 5885)
DIM QuitRed%(5886 TO 8187), PlayWhite%(8188 TO 10709), FameWhite%(10710 TO 12528)
DIM ManualWhite%(12529 TO 14428), QuitWhite%(14429 TO 16937), ExpYPos%(0 TO 2)
DIM Player%(0 TO 153), Enemy1%(154 TO 388), Enemy2%(389 TO 623), Picture%(1)
DIM OldE1%(72 TO 3077), OldE2%(72 TO 3077), Expl%(0 TO 2), Fire%(0 TO 2)
DIM YPos%(0 TO 2), XPos%(0 TO 2), FYPos%(0 TO 2), FXPos%(0 TO 2), ExpXPos%(0 TO 2)
DIM OldMoveTime!(2), Highscore(7) AS HsArray
'

'Constantes
CONST black = 0, blue = 1, green = 2, cyan = 3, red = 4, magenta = 5
CONST brown = 6, white = 7, grey = 8, bluebr = 9, greenbr = 10, cyanbr = 11
CONST redbr = 12, magentabr = 13, yellow = 14, whitebr = 15, blinking = 16
'

'Main
LoadConfiguration
ShowIntro
MainMenu
Quit
'

'Game key actions
UpKey:
  IF GameGoOn% = 0 OR YPos%(0) < 5 THEN RETURN
  ShowShip 0
  YPos%(0) = YPos%(0) - 5
  ShowShip 0
RETURN

DownKey:
  IF GameGoOn% = 0 OR YPos%(0) > 153 THEN RETURN
  ShowShip 0
  YPos%(0) = YPos%(0) + 5
  ShowShip 0
RETURN

RightKey:
  IF GameGoOn% = 0 OR XPos%(0) > 292 THEN RETURN
  ShowShip 0
  XPos%(0) = XPos%(0) + 9
  ShowShip 0
RETURN

LeftKey:
  IF GameGoOn% = 0 OR XPos%(0) < 7 THEN RETURN
  ShowShip 0
  XPos%(0) = XPos%(0) - 9
  ShowShip 0
RETURN
'

'Fire
FireKey:
  IF GameGoOn% = 0 OR Fire%(0) = 1 THEN RETURN
  PlaySound "PlayerFire"
  Fire%(0) = 1
  FXPos%(0) = XPos%(0) + 9
  FYPos%(0) = YPos%(0)
RETURN
'

'Bomb
BombKey:
  IF GameGoOn% = 0 OR (Expl%(1) AND Expl%(2)) THEN RETURN
  IF Bombs% > 0 THEN
    Bombs% = Bombs% - 1
    ShowStatus "Bombs"
    FOR i& = 0 TO 60 STEP 10
      RGB black, i&, i&, i&
    NEXT
    FOR i& = 60 TO 0 STEP -10
      RGB black, i&, i&, i&
    NEXT
    Expl%(1) = 1
    Expl%(2) = 1
    ExpRadius% = -1
  ELSE
    PlaySound "WrongButton"
  END IF
RETURN
'

'Pause
PauseKey:
  IF GameGoOn% = 0 THEN RETURN
  ShowShip 0
  ShowMessage "Pause"
  ShowShip 0
RETURN
'

'Leave Level
LeaveLevelKey:
  ExitGame% = 1
RETURN
'

'Error handler
ErrorHandler: ErrorMessages ""
'

'Data
IntroMusic:
  DATA "e","a","c","a","e","a","c","a","d","g","b","g","d","g","b","g","c"
  DATA "f","a","f","c","f","a","f","d","f","a","f","d","f","a","f","e","g"
  DATA "bg+eg+bg"
'

REM $STATIC
SUB ErrorMessages (Error$)
'ErrorMessages
SCREEN 0
WIDTH 80, 25
COLOR whitebr, bluebr
BEEP
LOCATE 1, 1: PRINT SPACE$(80)
LOCATE 1, 29: PRINT "Vogtsoft Errorhandler 1.0"
COLOR redbr, black

SELECT CASE Error$
  CASE "Case else": PRINT " VSEH Error: Too extreme value!"
  CASE ELSE: PRINT " Regular error: Error number"; ERR
END SELECT

COLOR white
SYSTEM
'
END SUB

SUB FadeOut (FadeMode$, FadeColor%)
'FadeOut
SELECT CASE FadeMode$
  CASE "Line"
    COLOR FadeColor%
    LOCATE 24, 1
    FOR i% = 1 TO 26
      PRINT
    NEXT
  CASE "Circle1"
    FOR r% = 1 TO 200
      CIRCLE (160, 100), r%, FadeColor%
      CIRCLE (160, 101), r%, FadeColor%
    NEXT
  CASE "Circle2"
    FOR r% = 200 TO 1 STEP -1
      CIRCLE (160, 100), r%, FadeColor%
      CIRCLE (160, 101), r%, FadeColor%
    NEXT
  CASE ELSE: ErrorMessages "Case else"
END SELECT
'
END SUB

SUB GetText (x%, y%, Lenght%, Format$, TextColor%, Special$)
'Shared variables
SHARED Text$
'

'Preparations
Text$ = ""
Letters% = 0
COLOR TextColor%
IF Format$ <> " " THEN LOCATE y%, x%: PRINT STRING$(Lenght%, Format$)
'

'Get text
DO
  DO
    Inp$ = INKEY$
  LOOP UNTIL Inp$ <> ""

  SELECT CASE ASC(Inp$)
    CASE 8: IF Letters% > 0 THEN GOSUB RemoveLetter                  'Back
    CASE 13: IF Letters% > 0 THEN EXIT DO                            'Return
    CASE 48 TO 57: GOSUB AddLetter                                   'Numbers
    CASE 65 TO 90: GOSUB AddLetter                                   'UCase
    CASE 97 TO 122: GOSUB AddLetter                                  'LCase
    CASE 32 TO 175: IF Special$ <> "FileName" THEN GOSUB AddLetter   'Others
    CASE ELSE
  END SELECT
LOOP
EXIT SUB
'

'Add/remove letters
AddLetter:
  IF Letters% < Lenght% THEN
    Letters% = Letters% + 1
    Text$ = Text$ + Inp$
    LOCATE y%, x%: PRINT Text$
  END IF
RETURN

RemoveLetter:
  Letters% = Letters% - 1
  Text$ = MID$(Text$, 1, Letters%)
  LOCATE y%, x%: PRINT Text$ + Format$
RETURN
'
END SUB

SUB HallOfFame (WhichHighscore$)
'Shared variables
SHARED Score%, Highscore() AS HsArray, Text$
'

'Which highscore?
SELECT CASE WhichHighscore$
  CASE "Check": GOSUB CheckHighscore
  CASE "Show": GOSUB ShowHallOfFame
               LOCATE 21, 2: PRINT " Press any key to continue...    "
               Wait$ = INPUT$(1)
               PlaySound "MenuReturn"
               COLOR white
               FadeOut "Circle1", 0
  CASE ELSE: ErrorMessages "Case else"
END SELECT
EXIT SUB
'

'Check highscore
CheckHighscore:
  FOR s% = 1 TO 7
    IF Score% >= Highscore(s%).HsScore THEN
      FOR j% = 7 TO (s% + 1) STEP -1
        SWAP Highscore(j%).HsScore, Highscore(j% - 1).HsScore
        SWAP Highscore(j%).HsName, Highscore(j% - 1).HsName
      NEXT
      Highscore(s%).HsScore = Score%
      GOSUB ShowHallOfFame
      LOCATE 21, 2: PRINT " Please enter your name "
      GOSUB GetHighscoreName
      GOSUB SaveHighscore
      EXIT FOR
    END IF
  NEXT
RETURN
'

'Get highscore name
GetHighscoreName:
  GetText 6, (4 + s% * 2), 20, ".", yellow, "Nothing"
  Highscore(s%).HsName = Text$
RETURN
'

'Save highscore
SaveHighscore:
  OPEN "highscre.dat" FOR OUTPUT AS #1
    FOR i% = 1 TO 7
      FOR j% = 1 TO 20
        PRINT #1, (ASC(MID$(Highscore(i%).HsName, j%, 1))) ^ 2;
      NEXT
      PRINT #1, Highscore(i%).HsScore;
    NEXT
  CLOSE #1
RETURN
'

'Hall of fame
ShowHallOfFame:
  FadeOut "Circle1", black
  Col! = 255
  FOR r% = 200 TO 1 STEP -1
    CIRCLE (160, 100), r%, Col!
    CIRCLE (160, 101), r%, Col!
    Col! = Col! - 1
  NEXT
 
  COLOR cyan
  LOCATE 3, 2: PRINT " Hall of Fame"
  FOR y% = 6 TO 18 STEP 2
    LOCATE y%, 5: PRINT SPACE$(30)
  NEXT
 
  y% = 4
  FOR k% = 1 TO 7
    y% = y% + 2
    LOCATE y%, 6: PRINT Highscore(k%).HsName
    LOCATE y%, 35 - LEN(STR$(Highscore(k%).HsScore))
    PRINT Highscore(k%).HsScore
  NEXT
RETURN
'
END SUB

SUB LoadConfiguration
'Shared Variables
SHARED Picture%(), Player%(), Enemy1%(), Enemy2%(), QuitRed%(), ManualRed%()
SHARED FameRed%(), PlayRed%(), StartTime!, Highscore() AS HsArray, Intro%
SHARED QuitWhite%(), ManualWhite%(), FameWhite%(), PlayWhite%()
'

'Turn off num-, scroll- and caps lock
DEF SEG = 64
POKE 23, PEEK(23) AND 63  'Caps Lock off
POKE 23, PEEK(23) AND 64  'Num Lock & Scroll Lock off
DEF SEG
'

'Misc
ON ERROR GOTO ErrorHandler
StartTime! = TIMER
FadeOut "Line", black
SCREEN 13
LOCATE 1, 1, 0, 31, 31
VIEW PRINT 1 TO 25
CLS
COLOR white
DEF SEG = &HA000
'

'Show loading
REDIM Picture%(4226)
OPEN "loading.ary" FOR INPUT AS #1
  FOR i% = 1 TO 4226
    INPUT #1, Picture%(i%)
  NEXT
CLOSE #1
PUT (65, 80), Picture%
REDIM Picture%(4120)
ShowTimber -1, -1
'

'Define color palette
FOR i% = 1 TO 200
  RGB (i% + 55), (i% / 3.2), 0, 0
  ShowTimber (i% / 5), (i% / 5)
NEXT
'

'Load highscore
OPEN "highscre.dat" FOR INPUT AS #1
  FOR i% = 1 TO 7
    a$ = ""
    FOR j% = 1 TO 20
      INPUT #1, a%
      a$ = a$ + CHR$(SQR(a%))
    NEXT
    Highscore(i%).HsName = a$
    INPUT #1, Highscore(i%).HsScore
  NEXT
CLOSE #1
ShowTimber 41, 50
'

'Load menu graphics
OPEN "menufont.ary" FOR INPUT AS #1
  FOR i% = 0 TO 16937
    SELECT CASE i%
      CASE IS <= 2431: INPUT #1, PlayRed%(i%)
      CASE IS <= 4171: INPUT #1, FameRed%(i%)
      CASE IS <= 5885: INPUT #1, ManualRed%(i%)
      CASE IS <= 8187: INPUT #1, QuitRed%(i%)
      CASE IS <= 10709: INPUT #1, PlayWhite%(i%)
      CASE IS <= 12528: INPUT #1, FameWhite%(i%)
      CASE IS <= 14428: INPUT #1, ManualWhite%(i%)
      CASE ELSE: INPUT #1, QuitWhite%(i%)
    END SELECT
    IF i% MOD 376 = 0 THEN ShowTimber (i% / 376 + 49), (i% / 376 + 50)
  NEXT
CLOSE #1
'

'Load ship graphics
OPEN "ships.ary" FOR INPUT AS #1
  FOR i% = 0 TO 623
    SELECT CASE i%
      CASE IS <= 153: INPUT #1, Player%(i%)
      CASE IS <= 388: INPUT #1, Enemy1%(i%)
      CASE ELSE: INPUT #1, Enemy2%(i%)
    END SELECT
    IF i% MOD 124 = 0 THEN ShowTimber (i% / 124 + 94), (i% / 124 + 95)
  NEXT
CLOSE #1
'

'Loading setup information
OPEN "setup.dat" FOR INPUT AS #1
  INPUT #1, Steering%
CLOSE #1
'

'Define keyboard
SHELL "MODE CON RATE=32 DELAY=1 > nul"  'Set keyboard speed
KEY 15, CHR$(Steering%) + CHR$(&H48)    'UP
KEY 16, CHR$(Steering%) + CHR$(&H50)    'DOWNN
KEY 17, CHR$(Steering%) + CHR$(&H4B)    'LEFT
KEY 18, CHR$(Steering%) + CHR$(&H4D)    'RIGHT
KEY 19, CHR$(0) + CHR$(&H1D)            'CTRL
KEY 20, CHR$(0) + CHR$(&H38)            'ALT
KEY 21, CHR$(0) + CHR$(&H39)            'Space Bar
KEY 22, CHR$(0) + CHR$(&H1)             'ESC
ON KEY(15) GOSUB UpKey
ON KEY(16) GOSUB DownKey
ON KEY(17) GOSUB LeftKey
ON KEY(18) GOSUB RightKey
ON KEY(19) GOSUB FireKey
ON KEY(20) GOSUB BombKey
ON KEY(21) GOSUB PauseKey
ON KEY(22) GOSUB LeaveLevelKey
'
END SUB

SUB MainMenu
'Shared variables
SHARED PlayRed%(), FameRed%(), ManualRed%(), Highscore() AS HsArray, MenuPos%
SHARED QuitRed%(), QuitWhite%(), ManualWhite%(), FameWhite%(), PlayWhite%()
'

'Main menu
MenuPos% = 1                                          'Set menu position
GOSUB ShowFrame                                       'Show red frame
GOSUB ShowButtons                                     'Show buttons
DO
  DO                                                  'Wait for key
    Inp$ = INKEY$
  LOOP WHILE Inp$ = ""

  IF LEN(Inp$) = 1 THEN                               'Analyse pressed key
    IF Inp$ = CHR$(13) THEN GOSUB MenuReturnKey
  ELSE
    SELECT CASE ASC(MID$(Inp$, 2, 1))
      CASE 72: GOSUB MenuUpKey
      CASE 80: GOSUB MenuDownKey
      CASE ELSE
    END SELECT
  END IF
LOOP
'

'Show buttons
ShowButtons:
  PUT (70, 43), PlayWhite%, PSET                      'Show all buttons white
  PUT (81, 76), FameWhite%, PSET
  PUT (79, 107), ManualWhite%, PSET
  PUT (51, 137), QuitWhite%, PSET
  SELECT CASE MenuPos%                                'Show selected button
    CASE 1: PUT (69, 44), PlayRed%, PSET
    CASE 2: PUT (80, 76), FameRed%, PSET
    CASE 3: PUT (80, 108), ManualRed%, PSET
    CASE 4: PUT (50, 138), QuitRed%, PSET
    CASE ELSE: ErrorMessages "Case else"
  END SELECT
RETURN
'

'Show frame
ShowFrame:
  Col! = 255
  FOR r% = 200 TO 130 STEP -1
    CIRCLE (160, 100), r%, Col!
    CIRCLE (160, 101), r%, Col!
    Col! = Col! - 2.84
  NEXT
RETURN
'

'Menu keys
MenuReturnKey:
  PlaySound "MenuReturn"                              'Play sound
  SELECT CASE MenuPos%                                'Analyse return key
    CASE 1: PlayTheGame
    CASE 2: HallOfFame "Show"
    CASE 3: ShowManual
    CASE 4: EXIT SUB
    CASE ELSE: ErrorMessages "Case else"
  END SELECT
  GOSUB ShowFrame
  GOSUB ShowButtons                                   'Show buttons
RETURN
'                                     
MenuUpKey:                                            'Move menu position up
  MenuPos% = MenuPos% - 1
  GOSUB CheckMenuPos
RETURN
'                                     
MenuDownKey:                                          'Move menu position down
  MenuPos% = MenuPos% + 1
  GOSUB CheckMenuPos
RETURN
'                                     
CheckMenuPos:                                         'Check menu position
  SELECT CASE MenuPos%
    CASE IS < 1: MenuPos% = 4
    CASE IS > 4: MenuPos% = 1
    CASE ELSE
  END SELECT
  GOSUB ShowButtons
  PlaySound "MenuReturn"
RETURN
'
END SUB

SUB PlaySound (WhichSound$)
'Play sound
SELECT CASE WhichSound$
  CASE "PlayerFire": PLAY "MB L20 T255 O0"
                     PLAY "GEFDC"
  CASE "EnemyFire": PLAY "MB L20 T255 O1"
                    PLAY "GEFDC"
  CASE "Explode": PLAY "MB L32 T200 O0"
                  FOR i% = 1 TO 3
                    PLAY "GEFDCE"
                  NEXT
  CASE "MenuPos": PLAY "MB L30 T200 O0"
                  PLAY "B"
  CASE "MenuReturn": PLAY "MB L50 T200 O0"
                     PLAY "A"
  CASE "WrongButton": PLAY "MB L32 T200 O0"
                      PLAY "E"
  CASE "Won": FOR i% = 100 TO 1000 STEP 10
                SOUND i%, .1
              NEXT
  CASE "Lost": FOR i% = 600 TO 100 STEP -3
                 SOUND i%, .1
               NEXT
  CASE ELSE: ErrorMessages "Case else"
END SELECT
'
END SUB

SUB PlayTheGame
'Shared variables
SHARED Expl%(), ExpXPos%(), ExpYPos%(), ExpRadius%, Damage%, Lives%, Score%
SHARED XPos%(), YPos%(), FXPos%(), FYPos%(), Fire%(), Mission%, DestrEnem%
SHARED ExitGame%, OldMoveTime!(), GameGoOn%, Enemies%, Picture%(), Bombs%
'

'Preparations
FadeOut "Circle1", black
FOR i% = 0 TO 2
  YPos%(i%) = 1000
  Expl%(i%) = 0
  Fire%(i%) = 0
NEXT
ExpXPos%(0) = 8
ExpYPos%(0) = 9
ExpXPos%(1) = 15
ExpYPos%(1) = 7
ExpXPos%(2) = 15
ExpYPos%(2) = 7
Mission% = 1
Score% = 0
Bombs% = 3
ExitGame% = 0
DestrEnem% = 0
Enemies% = 0
Damage% = 0
Lives% = 4
GOSUB GameBackground
ShowStatus "All"
Lives% = Lives% - 1
ShowMessage "Lives"
ShowStatus "Lives"
ShowShip 0
FOR i% = 15 TO 22
  KEY(i%) ON
NEXT
GameGoOn% = 1
'

'The game
DO
  FOR p1% = 1 TO 2
    IF Expl%(p1%) = 0 AND (TIMER - OldMoveTime!(p1%)) >= .04 THEN
      IF YPos%(p1%) >= 156 THEN YPos%(p1%) = 1000
      YPos%(p1%) = YPos%(p1%) + 1
      ShowShip p1%
      IF Enemies% >= 15 THEN GOSUB NewMission
      OldMoveTime!(p1%) = TIMER
    END IF
    IF XPos%(0) >= (XPos%(p1%) - 18) AND XPos%(0) <= (XPos%(p1%) + 30) AND Expl%(0) = 0 THEN GOSUB CheckPositions
  NEXT
 
  IF (Fire%(0) OR Fire%(1) OR Fire%(2)) AND (TIMER - OldFireTime!) > .05 THEN
    GOSUB Fire
    OldFireTime! = TIMER
  END IF
 
  IF (Expl%(0) OR Expl%(1) OR Expl%(2)) AND (TIMER - OldExplTime!) > .01 THEN
    GOSUB Explode
    OldExplTime! = TIMER
  END IF
LOOP UNTIL ExitGame%
'

'Mission end
VIEW
FOR k% = 15 TO 22
  KEY(k%) OFF
NEXT
HallOfFame "Check"
FadeOut "Circle1", black
EXIT SUB
'

'Check positions
CheckPositions:
  SELECT CASE YPos%(0)
    CASE (YPos%(p1%) - 15) TO (YPos%(p1%) + 14)
      Damage% = 1000
      GOSUB HitPlayer
      DestrEnem% = DestrEnem% + 1
      Expl%(p1%) = 1
      ExpRadius% = -1
    CASE IS >= (YPos%(p1%) + 14)
      IF Fire%(p1%) = 0 AND Expl%(p1%) = 0 THEN
        FXPos%(p1%) = XPos%(p1%)
        FYPos%(p1%) = YPos%(p1%) + 15
        Fire%(p1%) = 1
        PlaySound "EnemyFire"
      END IF
    CASE ELSE
  END SELECT
RETURN
'

'Fire
Fire:
  IF Fire%(0) THEN
    FYPos%(0) = FYPos%(0) - 5
    LINE (FXPos%(0), FYPos%(0) + 5)-(FXPos%(0), FYPos%(0) + 10), black
    FOR i% = 1 TO 2
      IF FXPos%(0) >= XPos%(i%) AND FXPos%(0) <= (XPos%(i%) + 30) AND FYPos%(0) <= YPos%(i%) + 14 AND Expl%(i%) = 0 THEN
        Fire%(0) = 0
        Expl%(i%) = 1
        ExpRadius% = -1
        EXIT FOR
      END IF
    NEXT
    IF FYPos%(0) < 0 THEN Fire%(0) = 0
    IF Fire%(0) THEN LINE (FXPos%(0), FYPos%(0))-(FXPos%(0), FYPos%(0) + 5), redbr
  END IF
'                                     
  FOR f% = 1 TO 2
    IF Fire%(f%) THEN
      FYPos%(f%) = FYPos%(f%) + 5
      SELECT CASE f%
        CASE 1
          PSET (FXPos%(1) + 4, FYPos%(1) - 5), black
          PSET (FXPos%(1) + 26, FYPos%(1) - 5), black
          IF YPos%(0) >= (FYPos%(1) - 15) AND YPos%(0) <= FYPos%(1) THEN
            IF XPos%(0) + 18 >= (FXPos%(1) + 4) AND XPos%(0) <= (FXPos%(1) + 26) THEN
              Fire%(1) = 0
              Damage% = Damage% + 15
              GOSUB HitPlayer
            END IF
          END IF
          IF Fire%(1) THEN
            PSET (FXPos%(1) + 4, FYPos%(1)), redbr
            PSET (FXPos%(1) + 26, FYPos%(1)), redbr
          END IF
        CASE 2
          LINE (FXPos%(2) + 15, FYPos%(2) - 5)-(FXPos%(2) + 15, FYPos%(2)), black
          IF YPos%(0) >= (FYPos%(2) - 15) AND YPos%(0) <= FYPos%(2) THEN
            IF XPos%(0) + 18 >= (FXPos%(2) + 15) AND XPos%(0) <= (FXPos%(2) + 15) THEN
              Fire%(2) = 0
              Damage% = Damage% + 50
              GOSUB HitPlayer
            END IF
          END IF
          IF Fire%(2) THEN LINE (FXPos%(2) + 15, FYPos%(2))-(FXPos%(2) + 15, FYPos%(2) + 5), cyanbr
        CASE ELSE: ErrorMessages "Case else"
      END SELECT
      IF FYPos%(f%) >= 170 THEN Fire%(f%) = 0
    END IF
  NEXT
RETURN
'

'Hit player
HitPlayer:
  IF Damage% > 44 THEN
    Expl%(0) = 1                               'Less lives
    ExpRadius% = -1
    GameGoOn% = 0
    Lives% = Lives% - 1
  END IF
  ShowStatus "Energie"
RETURN
'

'Player & enemy explode
Explode:
  SELECT CASE ExpRadius%
    CASE IS < 0
      PlaySound "Explode"
      ExpColor% = 255
      ExpRadius% = 0
    CASE 0 TO 20
      ExpRadius% = ExpRadius% + 1
      ExpColor% = ExpColor% - 8
      FOR e% = 0 TO 2
        IF Expl%(e%) THEN
          FOR k% = 0 TO 1
            CIRCLE (XPos%(e%) + ExpXPos%(e%), YPos%(e%) + ExpYPos%(e%) + k%), ExpRadius%, ExpColor%
          NEXT
        END IF
      NEXT
    CASE ELSE
      IF Expl%(0) THEN
        IF Lives% > 0 THEN
          ShowMessage "Lives"
          Damage% = 0
          Expl%(0) = 0
          FOR i% = 0 TO 2
            YPos%(i%) = 1000
          NEXT
        ELSE
          ExitGame% = 1
          PlaySound "Lost"
          ShowMessage "Lost"
        END IF
      END IF
      FOR c% = 1 TO 2
        IF Expl%(c%) THEN
          Score% = Score% + 5
          DestrEnem% = DestrEnem% + 1
          YPos%(c%) = 1000
          Expl%(c%) = 0
        END IF
      NEXT
      GameGoOn% = 0
      BLOAD "gameback.gra", 0
      ShowStatus "All"
      ShowShip 0
      GameGoOn% = 1
  END SELECT
RETURN
'

'NewMission
NewMission:
  IF Mission% < 9 THEN                         'New mission
    Mission% = Mission% + 1
    Enemies% = 0
    ShowStatus "Misc"
  ELSE
    PlaySound "Won"                            'Won
    ShowMessage "Won"
    ExitGame% = 1
  END IF
RETURN
'

'Game background
GameBackground:
  BackColor% = 56                              'Red background
  x2% = 160
  FOR x1% = 160 TO 1 STEP -1
    x2% = x2% + 1
    BackColor% = BackColor% + 1.24
    LINE (x1%, 1)-(x1%, 199), BackColor%, BF
    LINE (x2%, 1)-(x2%, 199), BackColor%, BF
  NEXT

  LINE (19, 180)-(68, 194), black, BF          'Energie frame
  LINE (19, 180)-(68, 194), grey, B
  LINE (68, 180)-(99, 194), black, BF          'Destroyed enemies frame
  LINE (68, 180)-(99, 194), grey, B
  LINE (99, 180)-(114, 194), black, BF         'Level frame
  LINE (99, 180)-(114, 194), grey, B
  LINE (250, 180)-(299, 194), black, BF        'Bomb frame
  LINE (250, 180)-(299, 194), grey, B
  LINE (204, 180)-(250, 194), black, BF        'Score frame
  LINE (204, 180)-(250, 194), grey, B
  LINE (125, 174)-(193, 195), black, BF        'Lives frame
  LINE (125, 174)-(193, 195), grey, B

  VIEW SCREEN (6, 4)-(312, 170), , grey        'Define window
  CLS 1                                        'Clear window

  RANDOMIZE 10                                 'Get stars
  FOR i% = 1 TO 700
    StarColor% = INT(RND * 4)
    y% = INT(RND * 200)
    x% = INT(RND * 320)
    SELECT CASE StarColor%
      CASE 0: StarColor% = 1
      CASE 1: StarColor% = 8
      CASE 2: StarColor% = 15
      CASE 3: StarColor% = 14
      CASE ELSE: ErrorMessages "Case else"
    END SELECT
    PSET (x%, y%), StarColor%
  NEXT

  BSAVE "gameback.gra", 0, 64000               'Save whole background
  GET (50, 77)-(260, 106), Picture%            'Save background for message
RETURN
'
END SUB

SUB Quit
'Shared variables
SHARED StartTime!
'

'Quit
FadeOut "Circle2", black
GOSUB ShowCredits
GOSUB ShowFreewareReminder
COLOR 7, 0
LOCATE 23
SYSTEM
'

'Show credits
ShowCredits:
  CLS
  FOR i% = 16 TO 39
    RGB i%, 0, 0, 0
  NEXT
  OPEN "credits.dat" FOR INPUT AS #1
    FOR i% = 1 TO 24
      INPUT #1, x%, y%, Col%, a$
      IF a$ <> "" THEN
        COLOR (i% + 15)
        LOCATE y%, x%: PRINT a$
        FOR i& = 0 TO 63
          RGB (i% + 15), 0, i&, i&
          IF LEN(INKEY$) THEN
            CLOSE #1
            RETURN
          END IF
        NEXT
      END IF
    NEXT
  CLOSE #1
  Wait$ = INPUT$(1)
RETURN
'

'Show freeware reminder
ShowFreewareReminder:
  SCREEN 0
  WIDTH 80, 25
  CLS
  OPEN "fwrem.dat" FOR INPUT AS #1
    DO
      INPUT #1, x%, y%, Col%, a$
      COLOR Col%
      LOCATE y%, x%: PRINT a$
    LOOP WHILE EOF(1) = 0
  CLOSE #1
  COLOR redbr
  LOCATE 5, 10: PRINT " You have played Astro Hero for"; INT((TIMER - StartTime!) / 60); "minute(s) and"; (TIMER - StartTime!) MOD 60; "second(s) "
RETURN
'
END SUB

SUB RGB (ColorToChange%, r&, G&, B&)
'RedGreenBlue
PALETTE ColorToChange%, (65536 * INT(B&)) + (256 * INT(G&)) + (1 * INT(r&))
'
END SUB

SUB ShowIntro
'Dim & load music array
DIM Music$(35)
RESTORE IntroMusic
FOR i% = 1 TO 35
  READ Music$(i%)
NEXT
'

'Show intro
FadeOut "Line", black

BLOAD "vogtsoft.gra", 0
  PLAY "O2"
  GOSUB PlayMusic
  FadeOut "Circle1", black

BLOAD "presents.gra", 0
  PLAY "O4"
  GOSUB PlayMusic
  FadeOut "Circle1", black

BLOAD "astroher.gra", 0
  PLAY "O1"
  GOSUB PlayMusic
  Music$(35) = Music$(35) + "+l4a"   'For the end
  PLAY "O3"
  GOSUB PlayMusic
  FadeOut "Circle1", black

ERASE Music$
EXIT SUB
'

'Play music
PlayMusic:
  PLAY "T255 L8 MF"
  FOR i% = 1 TO 35
    IF i% = 34 THEN PLAY "Mb"
    PLAY Music$(i%)
    IF LEN(INKEY$) THEN
      FadeOut "Circle1", black
      EXIT SUB
    END IF
  NEXT
RETURN
'
END SUB

SUB ShowManual
'Shared variables
SHARED Player%(), Enemy1%(), Enemy2%()
'

'Manual
OPEN "manual.dat" FOR INPUT AS #1
  Page% = 0
  LOCATE 24, 1
  DO
    Page% = Page% + 1
    FOR i% = 1 TO 24
      INPUT #1, x%, y%, Col%, a$
      COLOR Col%
      PRINT a$
    NEXT
    IF Page% = 2 THEN
      PUT (18, 32), Player%, XOR
      PUT (16, 89), Enemy1%, XOR
      PUT (16, 137), Enemy2%, XOR
    END IF
    Wait$ = INPUT$(1)
  LOOP UNTIL EOF(1)
CLOSE #1
FadeOut "Line", black
'
END SUB

SUB ShowMessage (WhichMessage$)
'Shared variables
SHARED Picture%(), Mission%, Lives%
'

'Which message?
FOR i% = 15 TO 22
  KEY(i%) OFF
NEXT
LINE (50, 77)-(260, 106), black, BF
LINE (50, 77)-(260, 106), 16, B
COLOR 16
SELECT CASE WhichMessage$
  CASE "Pause": LOCATE 12, 10: PRINT "Pause - Press any key"
  CASE "Lives": SELECT CASE Lives%
                  CASE 3: LOCATE 12, 12: PRINT "You have 3 lives"
                  CASE 2: LOCATE 12, 9: PRINT "You have still 2 lives"
                  CASE 1: LOCATE 12, 9: PRINT "This is your last life!"
                  CASE ELSE: ErrorMessages "Case else"
                END SELECT
  CASE "Won": LOCATE 11, 8: PRINT "Congratulations, you won!"
              LOCATE 12, 8: PRINT "You are now an Astro Hero"
              LOCATE 13, 13: PRINT "Press any key..."
  CASE "Lost": LOCATE 11, 8: PRINT "Oh no, you lost the game!"
               LOCATE 12, 9:  PRINT "I hope you'll do better"
               LOCATE 13, 9: PRINT "next time. Press a key.."
  CASE ELSE: ErrorMessages "Case else"
END SELECT
'

'FadeOut in/out and wait
FOR i& = 20 TO 60
  RGB 16, 10, i&, i&
NEXT
Wait$ = INPUT$(1)
FOR i& = 60 TO 20 STEP -1
  RGB 16, 10, i&, i&
NEXT
PUT (50, 77), Picture%, PSET
FOR i% = 15 TO 22
  KEY(i%) ON
NEXT
'
END SUB

SUB ShowShip (WhichShip%)
'Shared variables
SHARED Player%(), Enemy1%(), Enemy2%(), OldE1%(), OldE2%(), XPos%(), YPos%()
SHARED Enemies%
'

'Show ships
SELECT CASE WhichShip%
  CASE 0
    IF YPos%(0) > 999 THEN
      YPos%(0) = 124
      XPos%(0) = 150
    END IF
    PUT (XPos%(0), YPos%(0)), Player%, XOR
  CASE 1
    SELECT CASE YPos%(1)
      CASE IS > 999: GOSUB NewE1Position
      CASE IS > 155: FOR y% = 156 TO 170
                       PUT (XPos%(1), y%), OldE1%(y% * 18), PSET
                     NEXT
      CASE ELSE: PUT (XPos%(1), YPos%(1)), Enemy1%, PSET
                 PUT (XPos%(1), YPos%(1) - 1), OldE1%((YPos%(1) - 1) * 18), PSET
      END SELECT
  CASE 2
    SELECT CASE YPos%(2)
      CASE IS > 999: GOSUB NewE2Position
      CASE IS > 155: FOR y% = 156 TO 170
                       PUT (XPos%(2), y%), OldE2%(y% * 18), PSET
                     NEXT
      CASE ELSE: PUT (XPos%(2), YPos%(2)), Enemy2%, PSET
                 PUT (XPos%(2), YPos%(2) - 1), OldE2%((YPos%(2) - 1) * 18), PSET
    END SELECT
  CASE ELSE: ErrorMessages "Case else"
END SELECT
EXIT SUB
'

'Enemy positions
NewE1Position:
  Enemies% = Enemies% + 1
  YPos%(1) = 5
  RANDOMIZE TIMER
  DO
    DO
      XPos%(1) = INT(RND * 275) + 7
    LOOP UNTIL XPos%(2) < (XPos%(1) - 30) OR XPos%(2) > (XPos%(1) + 30)
  LOOP UNTIL XPos%(0) < (XPos%(1) - 15) OR XPos%(0) > (XPos%(1) + 30)
  FOR y% = 4 TO 170
    GET (XPos%(1), y%)-(XPos%(1) + 30, y%), OldE1%(y% * 18)
  NEXT
RETURN
'                                     
NewE2Position:
  Enemies% = Enemies% + 1
  YPos%(2) = 5
  RANDOMIZE TIMER
  DO
    DO
      XPos%(2) = INT(RND * 275) + 7
    LOOP UNTIL XPos%(1) < (XPos%(2) - 30) OR XPos%(1) > (XPos%(2) + 30)
  LOOP UNTIL XPos%(0) < (XPos%(2) - 15) OR XPos%(0) > (XPos%(2) + 30)
  FOR y% = 4 TO 170
    GET (XPos%(2), y%)-(XPos%(2) + 30, y%), OldE2%(y% * 18)
  NEXT
RETURN
'
END SUB

SUB ShowStatus (WhichStatus$)
'Shared variables
SHARED Lives%, Bombs%, Score%, Damage%, Player%(), Mission%, DestrEnem%
'

'Which status
VIEW                                                       'Define window

SELECT CASE WhichStatus$                                   'Which status?
  CASE "Lives": GOSUB Lives
  CASE "Energie": GOSUB Energie
  CASE "Bombs": GOSUB Bombs
  CASE "Misc": GOSUB Misc
  CASE "All": GOSUB Lives
              GOSUB Energie
              GOSUB Bombs
              GOSUB Misc
  CASE ELSE: ErrorMessages "Case else"
END SELECT

VIEW SCREEN (6, 4)-(312, 170), , grey                      'Define window
EXIT SUB                                                   'Exit status
'

'Show status
Lives:           
  LINE (126, 175)-(192, 194), black, BF                    'Show lives
  FOR x% = 1 TO (Lives% - 1)
    PUT ((x% * 22 + 106), 177), Player%, XOR
  NEXT
RETURN

Energie:
  FOR x% = 21 TO 66 STEP 3                                 'Show energie
    LINE (x%, 182)-(x%, 192), grey, BF
  NEXT
  FOR x% = 21 TO (66 - Damage%) STEP 3
    SELECT CASE x%
      CASE 52 TO 66: Col% = green
      CASE 37 TO 51: Col% = yellow
      CASE IS <= 36: Col% = red
      CASE ELSE: ErrorMessages "Case else"
    END SELECT
    LINE (x%, 182)-(x%, 192), Col%, BF
  NEXT
RETURN

Bombs:
  FOR x% = 252 TO 297 STEP 3                               'Show bombs
    LINE (x%, 182)-(x%, 192), grey, BF
  NEXT
  IF Bombs% > 0 THEN
    FOR x% = 252 TO (Bombs% * 15 + 252) STEP 3
      LINE (x%, 182)-(x%, 192), cyan, BF
    NEXT
  END IF
RETURN

Misc:
  COLOR cyan                                               'Show score
  LOCATE 24, 27: PRINT "00000"
  LOCATE 24, 33 - LEN(STR$(Score%)): WRITE Score%
  LOCATE 24, 14: WRITE Mission%                            'Show level
  LOCATE 24, 10: PRINT "000"                               'Show destr. enem.
  LOCATE 24, 14 - LEN(STR$(DestrEnem%)): WRITE DestrEnem%
RETURN
'
END SUB

SUB ShowTimber (StartPercent!, EndPercent!)
'Show timber
IF StartPercent! < 0 THEN
  LINE (65, 139)-(256, 151), grey, BF                        'Show border
  LINE (65, 139)-(256, 151), blue, B
ELSE
  FOR i% = (StartPercent! * 1.89) TO (EndPercent! * 1.89)    'Show timber
    LINE ((66 + i%), 140)-((66 + i%), 150), white, BF
  NEXT
END IF
'
END SUB

