'
' Astro Hero Setup 1.1
' Copyright by Stefan Vogt 1994 - 1997
'

'Declare subs
DECLARE SUB LeaveSetup ()
DECLARE SUB ResetHighscore ()
DECLARE SUB ShowInfo ()
DECLARE SUB AskHighscore ()
DECLARE SUB AskKeys ()
DECLARE SUB SaveSetup ()
'

'Types
TYPE HsArray
 HsName AS STRING * 20
 HsScore AS INTEGER
END TYPE
'

'Constantes
CONST black = 0, blue = 1, green = 2, cyan = 3, red = 4, magenta = 5
CONST brown = 6, white = 7, grey = 8, bluebr = 9, greenbr = 10, cyanbr = 11
CONST redbr = 12, magentabr = 13, yellow = 14, whitebr = 15, blinking = 16
'

'Main
ShowInfo
AskKeys
AskHighscore
SaveSetup
SYSTEM
'"

SUB AskHighscore
'Ask highscore
PRINT
PRINT "Do you want to reset highscore?"
PRINT " 1. Yes"
PRINT " 2. No"

DO
  DO
    Inp$ = INKEY$
  LOOP UNTIL Inp$ <> ""

  SELECT CASE Inp$
    CASE "1": ResetHighscore
              PRINT " Highscore reseted"
              EXIT DO
    CASE "2": PRINT " Highscore not reseted"
              EXIT DO
    CASE "": LeaveSetup
    CASE ELSE
  END SELECT
LOOP
'
END SUB

SUB AskKeys
'Shared variables
SHARED Steering%
'

'Ask keys
COLOR white, black
PRINT
PRINT "Please define keyboard:"
PRINT " 1. Use regular arrow keys for steering (default)"
PRINT " 2. Use numberblock keys for steering (only for some notebook users)"

DO
  DO
    Inp$ = INKEY$
  LOOP UNTIL Inp$ <> ""

  SELECT CASE Inp$
    CASE "1": Steering% = 128
              PRINT " Regular arrow keys selected"
              EXIT DO
    CASE "2": Steering% = 0
              PRINT " Numberblock keys selected"
              EXIT DO
    CASE "": LeaveSetup
    CASE ELSE
  END SELECT
LOOP
'
END SUB

SUB LeaveSetup
'Leave setup
PRINT
PRINT "Canceled by user"
PRINT "Setup not saved"
SYSTEM
'
END SUB

SUB ResetHighscore
'Reset highscore
DIM Highscore(1 TO 7) AS HsArray

Highscore(1).HsName = "Ueli"
Highscore(1).HsScore = 590
Highscore(2).HsName = "Luke Skytalker"
Highscore(2).HsScore = 310
Highscore(3).HsName = "Oskar"
Highscore(3).HsScore = 105
Highscore(4).HsName = "Indiana Bones"
Highscore(4).HsScore = 90
Highscore(5).HsName = "Beppo"
Highscore(5).HsScore = 75
Highscore(6).HsName = "Wrf"
Highscore(6).HsScore = 35
Highscore(7).HsName = "Daita"
Highscore(7).HsScore = 10

OPEN "highscre.dat" FOR OUTPUT AS #1
  FOR i% = 1 TO 7
    FOR j% = 1 TO 20
      PRINT #1, (ASC(MID$(Highscore(i%).HsName, j%, 1))) ^ 2;
    NEXT
   PRINT #1, Highscore(i%).HsScore;
  NEXT
CLOSE #1
'
END SUB

SUB SaveSetup
'Shared variables
SHARED Steering%
'

'Save setup
OPEN "setup.dat" FOR OUTPUT AS #1
  WRITE #1, Steering%
CLOSE #1
PRINT
PRINT "Setup saved"
'
END SUB

SUB ShowInfo
'Show info
SCREEN 0
WIDTH 80, 25
CLS
COLOR yellow, bluebr
PRINT SPACE$(80)
LOCATE 1, 13: PRINT "Astro Hero Setup 1.1 - (c) by Stefan Vogt 1996 - 1997"
'
END SUB

